#include <stdio.h>
#include <stdint.h>
#include <math.h> 
#include <conio.h>

/*
int ReadChar(void)
{
	return _getche();
}
*/

char NSEW[] = "NSEWnsew";

char *demoText;
int demoCnt = -1;

char ReadChar(void)
{
	//  return _getch();

	demoCnt++;
	if (demoText[demoCnt] == 0)       
		demoCnt = 0;
	return demoText[demoCnt];
}


int ReadNumber2(int *X)
{
	int number = 0;
	char ch;
	char beg = 1;
	int k = 0;
	while (1)
	{
		ch = ReadChar();
		if (((ch == ' ') || (ch == '\t')) && beg) continue;
		beg = 0;
		if ((ch < '0') || (ch > '9')) break;
		if (number > INT32_MAX / 10) break;
		number = 10 * number + (ch - '0');
		k++;
	}
	*X = number;
	if (ch == '.') return 0;
	if ((ch != ' ') && (ch != '\n') && (ch != '\r')) return -1;
	return k;
}

int ReadNumber()
{
	int Number = 0;
	int k;
	k = ReadNumber2(&Number);
	if (k<=0) return -1;
	return Number;
}

int Read_NSEW()
{
	char NSEW[] = "NSEWnsew";
	int ch;
	char *cp;
	while ((ch = ReadChar()) == ' ')
		;
	for (cp = NSEW; *cp; cp++)
	{
		if (ch == *cp) return (cp - NSEW) % 4;
	}
	return -1;
}

int ReadGPS(double *X)
{
	int degree, code, min, sec, tenths, k;
	double result;
	degree = ReadNumber();
	if (degree < 0) return -1;
	code = Read_NSEW();
	if (code < 0) return -1;
	k = ReadNumber2(&min);
	if (k < 0) return -1;
	if (k > 0)
	{
		k = ReadNumber2(&sec);
		if (k < 0) return -1;
		if (k == 0) k = ReadNumber2(&tenths);
		if (k <= 0) return -1;
		result = degree + min / 60.0 + sec / 3600.0 + tenths / 3600.0 / pow(10.0, k);
	}
	else
	{
		k = ReadNumber2(&tenths);
		if (k <= 0) return -1;
		result = degree + min / 60.0 + tenths / 60.0 / pow(10, k);
	}
	*X = result;
	return code;
}

int main()
{
	double x;
	int k;
	demoText = (char *)"49 N 43 25.721\n"; demoCnt = -1;
	k = ReadGPS(&x);
	if (k >= 0)
		printf("Coordinate: %c %0.8f\n", NSEW[k], x);
	else
		printf("Error\n");
	demoText = (char *)"13 E 21 2.549\n"; demoCnt = -1;
	k = ReadGPS(&x);
	if (k >= 0)
		printf("Coordinate: %c %0.8f\n", NSEW[k], x);
	else
		printf("Error\n");
	demoText = (char *)"49 N 43.428683\n"; demoCnt = -1;
	k = ReadGPS(&x);
	if (k >= 0)
		printf("Coordinate: %c %0.8f\n", NSEW[k], x);
	else
		printf("Error\n");
	demoText = (char *)"13 E 21.042483\n"; demoCnt = -1;
	k = ReadGPS(&x);
	if (k >= 0)
		printf("Coordinate: %c %0.8f\n", NSEW[k], x);
	else
		printf("Error\n");


	return 0;
}

